/*------------------------------------------------*/
/* 22process/shmap_info.c                         */

#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdio.h>
#include <errno.h>
#include "shmap.h"

int main(void) {
    int segment_id; /* identifikace zdilene pameti     */
    struct shmid_ds buf; /* informace o zdilene pameti */
    char *pole;
    int ret;

    segment_id = shmget(SKEY, sizeof(char)*N,
             S_IRUSR | S_IWUSR);
    if(segment_id < 0) {
        if(errno == ENOENT) {
            fprintf(stderr,"Segment s key = %i neexistuje.\n", SKEY);
            return 1;
        }
        fprintf(stderr, "Něco je špatně.\n");
        return 1;
    }
    ret = shmctl(segment_id, IPC_STAT, &buf);
    if(ret < 0) {
        fprintf(stderr, "Něco je špatně. Žeby přístupová práva?\n");
        return 1;
    }
    
    printf("Key = %i, Id = %i\n", buf.shm_perm.__key, segment_id);
    pole = (char *) shmat(segment_id, NULL, 0);
    printf("Pole obsahuje '%s'\n", pole);
    shmdt(pole);

    return 0;
}

/*------------------------------------------------*/
