/*------------------------------------------------*/
/* 23processKomunikace/semafory3.c                */

#include <sys/types.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdbool.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <semaphore.h>

#define N 1024*1024
#define SEM_NAME "mujSemafor"

void producent(int segment_id)
{
	int *m;
	sem_t *sem;
	int i, j;
	srand(0);
	m = (int *)shmat(segment_id, NULL, 0);
	sem = (sem_t *) m;
	m = (int *) (((char *)m) + sizeof(sem_t));
	printf("Producent start\n");
	for (i = 0; i <= 200; i++) {
		sem_wait(sem);
		for (j = 0; j < N; j++) {
			memcpy(m + j, &i, sizeof(int));
		}
		sem_post(sem);
		usleep(rand() % 50);
	}
	printf("Producent konec\n");
	sem_close(sem);
	shmdt(m);
}

void consumer(int segment_id)
{
	int *m;
	sem_t *sem;
	int i;
	m = (int *)shmat(segment_id, NULL, 0);
	sem = (sem_t *) m;
	m = (int *) (((char *)m) + sizeof(sem_t));
	for (i = 0; i <= 10; i++) {
		sem_wait(sem);
		printf("m = %i ... %i", *m, *(m + (N - 1)));
		sem_post(sem);
		usleep(100000);
		printf("\n");
	}
	sem_close(sem);
	shmdt(m);
}

int main(void)
{
	pid_t pid;
	int segment_id;
	sem_t *sem;

	segment_id =
	    shmget(IPC_PRIVATE, sizeof(sem_t) + N * sizeof(int),
		   IPC_CREAT | S_IRUSR | S_IWUSR);
	sem = (sem_t *) shmat(segment_id, NULL, 0);
	sem_init(sem, 1, 1);

	pid = fork();
	if (pid == 0) {
		producent(segment_id);
	} else {
		consumer(segment_id);
		waitpid(pid, NULL, 0);
		sem_destroy(sem);
	}
	return 0;
}

/*------------------------------------------------*/
