/*------------------------------------------------*/
/* 25daemon/log.c                                 */
#include <stdio.h>
#include <time.h>
#include <stdarg.h>
#include <sys/types.h>
#include <unistd.h>
#include "log.h"

static FILE *logfile;

int openLog()
{
    char tmp[25];
    sprintf(tmp, "/tmp/demon.%i.log", getpid());
    logfile = fopen(tmp, "a+");
    if (logfile == NULL) {
        perror("fopen");
        return 2;
    }
    return 0;
}

int writeLog(char *format, ...)
{
    time_t sec;
    struct tm *cas;
    char scas[50];
    char text[512];
    va_list ap;

    sec = time(NULL);
    cas = localtime(&sec);
    strftime(scas, 50, "%F %T", cas);

    va_start(ap, format);
    vsnprintf(text, 512, format, ap);
    va_end(ap);

    fprintf(logfile, "[%5d,  %s] %s\n", getpid(), scas, text);
    return fflush(logfile);
}

int closeLog()
{
    return fclose(logfile);
}

/*------------------------------------------------*/
