/*------------------------------------------------*/
/* 29postgresql/create.c                          */
#include <libpq-fe.h>
#include "pg-utils.h"

int main(int argc, char **argv)
{
    PGresult *res;
    PGconn *conn = pgconnect(argc, argv);
    if (conn == NULL) {
        return 1;
    }
    printf("Conection OK\n");

    int i;
    char *sql[] = {
        "DROP TABLE IF EXISTS databases",
        "DROP TABLE IF EXISTS config",
        "DROP TYPE IF EXISTS db_type",
        "CREATE TYPE db_type AS ENUM('mysql','postgres','oracle','sqlite')",
        "CREATE TABLE config(\
            id SERIAL PRIMARY KEY,\
            major INTEGER NOT NULL CHECK(major >= 0),\
            minor VARCHAR(7) CHECK (minor ~ '[0-9.]+')\
        )",
        "CREATE TABLE databases(\
            id SERIAL PRIMARY KEY,\
            config_id integer NOT NULL REFERENCES config(id) ON DELETE CASCADE,\
            \"type\" db_type NOT NULL,\
            enabled bool NOT NULL DEFAULT false,\
            name VARCHAR(255),\
            password VARCHAR(255),\
            schema VARCHAR(255),\
            host VARCHAR(255),\
            port integer\
        )",
        NULL
    };

    i = -1;
    while (sql[++i]) {
        res = PQexec(conn, sql[i]);
        printStatus(res);
        PQclear(res);
    }
    PQfinish(conn);
    return 0;
}

/*------------------------------------------------*/
